'+--------------------------------------------------------------------------+
'|                                                                          |
'|                                PROGRESS                                  |
'|                                                                          |
'|          "WinLIFT skin engine" input + progress bar example.             |
'|                                                                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|            8 Domaine de Rochagnon. 38800 Champagnier  FRANCE             |
'|                       http://www.zapsolution.com                         |
'|                    E-mail: pterrier@zapsolution.com                      |
'|                                                                          |
'|                   copyright (c) 1999 Patrice TERRIER                     |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 02-14-2000                         |
'|                        Last revised : 02-17-2000                         |
'+--------------------------------------------------------------------------+

' ** Eliminate unnecessary macros
%NOANIMATE    = 1
%NODRAGLIST   = 1
%NOHEADER     = 1
%NOIMAGELIST  = 1
%NOLISTVIEW   = 1
%NOTABCONTROL = 1
%NOTRACKBAR   = 1
%NOTREEVIEW   = 1
%NOUPDOWN     = 1

%NOBUTTON     = 1
%NOCOMBOEX    = 1
%NOEDIT       = 1
%NOCOMBO      = 1
%NOLIST       = 1
%WINAPI       = 1
%NOREBAR      = 1
%NOTOOLBAR    = 1
%NOTOOLTIPS   = 1
'%NOSTATUSBAR  = 1

#COMPILE EXE

#INCLUDE "WIN32API.INC"
#INCLUDE "SKENGINE.INC"
#INCLUDE "COMMCTRL.INC"
#RESOURCE "INPUT.PBR"

TYPE IDVALL              ' Input field for database
    Itype    AS INTEGER  ' Input type 
    Isize    AS INTEGER  ' Input size length in characters
    Iwidth   AS INTEGER  ' Input box width in pixels
    IHeight  AS INTEGER  ' Input box height in pixels
    ReadOnly AS INTEGER  ' Input ES_READONLY on or off
    X        AS INTEGER  ' Left X coordinate for text display
    Y        AS INTEGER  ' Upper Y coordinate for text display
    Edge     AS LONG     ' the frame border to use.
    Fore     AS LONG     ' the foreground color to use.
    Back     AS LONG     ' the background color to use.
    MinV     AS INTEGER  ' Input UpDn Min value
    MaxV     AS INTEGER  ' Input UpDn Max value
    SeedV    AS INTEGER  ' Input UpDn Seed value
    Iclass   AS BYTE     ' Input 1 combodropdown, 2 updn, 10 combodropdownlist
    hEdit    AS LONG     ' Input returns the true edit handle (combo)
    hTitle   AS LONG     ' Input returns the input title handle
    offset   AS INTEGER  ' Offset inside of the record buffer.
    Search   AS BYTE     ' Search flag 1-9 (1-5 alpha, 5-6 num)
END TYPE

GLOBAL hInst&
GLOBAL hFrame&, hCTL&, hStatus&, UseTheme$
GLOBAL sk AS SKALL, ski() AS IDVALL, Q$()
GLOBAL Mact$(), cfgStr$()
GLOBAL zTmp AS ASCIIZ * 256
GLOBAL ScrWidth&, ScrHeight&
GLOBAL hFont&, IsCombo$

GLOBAL zTruePath AS ASCIIZ * 128

GLOBAL hEdit&()

GLOBAL xFrame&, yFrame&

' Message function
FUNCTION WndProc& (BYVAL hWnd&, BYVAL Msg&, BYVAL wParam&, BYVAL lParam&) EXPORT

    LOCAL siz AS SIZEL
    LOCAL ps AS PAINTSTRUCT
    LOCAL rc AS RECT
    LOCAL dinfo AS DOCINFO
    LOCAL wMsg AS tagMsg
    LOCAL zLibName AS ASCIIZ * 128
    LOCAL zFileName AS ASCIIZ * 128

    LOCAL lpdis AS DRAWITEMSTRUCT
    LOCAL lpmis AS MEASUREITEMSTRUCT

    STATIC PassFile$, IsLocked&

    STATIC IDTHEME&, hTheme&, IDSECUR&
    STATIC WasInput&, hProgress&, hCombine&
    STATIC IDREQFIRST&, IDREQLAST&, IDSTART&

    STATIC hBound&(), hBut&()

    STATIC WasID&, BackBrush&, CharHeight&

    STATIC hSecur&, hBut3D&(), hButStart&, ProgressOn&

    DIM hBut&(10)

    Ret& = skGetMessage(hWnd&, Msg&, wParam&, lParam&)
    IF Ret& THEN FUNCTION = Ret&: EXIT FUNCTION
    
    wP% = LOWRD(wParam&): ID& = HIWRD(wParam&)

NewMessage:
    SELECT CASE Msg&

    CASE %WM_CREATE
         BackBrush& = CreateSolidBrush(skGetSysColor(%SKCOLOR_INACTIVECAPTION))

    CASE %WM_CTLCOLORLISTBOX
         SetTextColor wParam&, skGetSysColor (%SKCOLOR_CAPTIONTEXT)
         SetBkColor wParam&, skGetSysColor (%SKCOLOR_INACTIVECAPTION)
         FUNCTION = BackBrush&
         EXIT FUNCTION

    CASE %WM_ERASEBKGND
         FUNCTION = 1: EXIT FUNCTION         

    CASE %WM_PAINT
         SELECT CASE hWnd&
         CASE hCTL& 
         
            IF (GetWindowLong(hCTL&, %GWL_STYLE) AND %WS_CLIPCHILDREN) THEN
               CALL InvalidateRect(hCTL&, BYVAL %NULL, 0)
            END IF

            CALL GetClientRect(hWnd&, rc)
            Xin& = rc.nRight: Yin& = rc.nBottom
            hDC& = BeginPaint(hWnd&, ps)

            IF (GetWindowLong(hCTL&, %GWL_STYLE) AND %WS_CLIPCHILDREN) = 0 THEN
               CALL skTileBlt(hDC&, 0, 0, Xin&, Yin&, skCtlBack)
            END IF

            'CALL skDrawEdge(hDC&, 0, 205-203, 650-70, 338, %BDR_SUNKENOUTER, %BF_RECT)
            CALL skDrawRect3D(hDC&, 0, 205-203, 650-70, 338, skGetSysColor(%SKCOLOR_WINDOW), skGetSysColor(%SKCOLOR_WINDOWTEXT))
            
            IF IsLocked& THEN zTmp = "LOCKUP" ELSE zTmp = "ULOCK"
            hIcon& = LoadIcon(hInst&, zTmp)
            CALL DrawIconEx(hDC&, 643, 164, hIcon&, 32, 32, 0, %NULL, %DI_NORMAL)

            CALL EndPaint(hWnd&, ps)
            FUNCTION = 0: EXIT FUNCTION
         END SELECT       
                      
    CASE %WM_INITDIALOG
         IF wParam& = hFrame& THEN
         
            IF LEN(UseTheme$) = 0 THEN UseTheme$ = "INPUT"
         
            PassFile$ = zTruePath + cfgStr$(34) + ".PWD"
            IsLocked& = skExist(PassFile$)

            Style& = %WS_CHILD OR %WS_VISIBLE OR %SS_ETCHEDHORZ
            hSt& = CreateWindowEx(0, "STATIC", "", Style&, 0, 203-203, 803-70, 0, hCTL&, 0, hInst&, BYVAL %NULL)

            Obj& = 0: Y& = 219-203-6: yStep& = 17
            FOR K& = 1 TO 9
                INCR Obj&
                hBut&(K&) = skRadioButton(hCTL&, skConvert(cfgStr$(K& + 3)), 587, Y&, 135, yStep&, Obj&)
                CALL skSetCTLFont(hBut&(K&), hFont&)
                Y& = Y& + yStep&
            NEXT

            sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
            sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
            
            INCR Obj&: IDSECUR& = Obj&        
            sk.button = 1
            hSecur& = skBut3D(hCTL&, cfgStr$(65), skCaptionFont, 657-70, 376+27-203, 135, 23, Obj&, sk)
            sk.Fore = 0&
            CALL skTabStop(hSecur&)

            INCR Obj&: IDTHEME& = Obj&
            Style& = %WS_CHILD OR %WS_VISIBLE
            hTheme& = CreateWindowEx(0, "STATIC", (cfgStr$(16)), Style&, 657-70, 376+54-203, 135, 23, hCTL&, 0, hInst&, BYVAL %NULL)
            CALL skSetColor(hTheme&, skGetSysColor(%SKCOLOR_WINDOWTEXT), -1) ' -1 = Transparent background
            CALL skSetCTLFont(hTheme&, hFont&)

            Style& = %WS_CHILD OR %WS_VISIBLE OR %ES_LEFT OR %CBS_AUTOHSCROLL OR _
                     %CBS_UPPERCASE OR %CBS_DROPDOWNLIST OR %CBS_SORT OR %WS_VSCROLL OR %WS_TABSTOP OR _
                     %CBS_OWNERDRAWFIXED OR %CBS_HASSTRINGS

            StyleEx& = %WS_EX_CLIENTEDGE
            hTheme& = CreateWindowEx(StyleEx&, "COMBOBOX", "", _
                                     Style&, _
                                     657-70, 376+71-203, 135, 100, _
                                     hCTL&, IDTHEME&, hInst&, BYVAL %NULL)

            CALL skSetCTLFont(hTheme&, hFont&)
            ThemeName$ = DIR$(zTruePath + "*.THM")
            DO WHILE LEN(ThemeName$)
               CALL skAddStringCombo(hTheme&, EXTRACT$(ThemeName$, "."))
               ThemeName$ = DIR$
            LOOP
            zTmp = UseTheme$
            CALL SendMessage(hTheme&, %CB_SETCURSEL, SendMessage(hTheme&, %CB_FINDSTRING, -1, VARPTR(zTmp)), 0)
            CALL skTabStop(hTheme&)

            Style& = %WS_CHILD OR %WS_VISIBLE
            zTmp = cfgStr$(48)
            hCombine& = CreateWindowEx(0, "STATIC", zTmp, Style&, 657-70, 376+71+60-203, 135, 23, hCTL&, 0, hInst&, BYVAL %NULL)
            CALL skSetColor(hCombine&, skGetSysColor(%SKCOLOR_WINDOWTEXT), -1) ' -1 = Transparent background
            CALL skSetCTLFont(hCombine&, hFont&)
            INCR Obj&: IDCOMBINE& = Obj&
            hCombine& = skCheckButton(hCTL&, skConvert(cfgStr$(49)), 587, 317, 135, 20, IDCOMBINE&)
            CALL skSetCTLFont(hCombine&, hFont&)
            CALL skTabStop(hCombine&)
            CALL SendMessage(hCombine&, %BM_SETCHECK, 1, 0)
            CALL skSetCheck(hCombine&, 1)

            REDIM hEdit&(16)
            REDIM hBound&(16)
            REDIM R$(1 TO 17)
            REDIM Ti$(1 TO 17)
            REDIM ski(1 TO 17) AS IDVALL

          ' Set title of input fields
            FOR K& = 50 TO 64
                Ti$(K& - 49) = skConvert(cfgStr$(K&)): cfgStr$(K&) = ""
            NEXT    

          ' Initialize the input form
            CALL InitInput(hCTL&, 16, 219-203, Ti$(), hBound&())
          ' Set the TAB order
            TabOrder$ = skCode(cfgStr$(2)) ' CHR$(1,3,4,5,6,7,8,9,10,11,12,13,14,15)
            FOR K& = 1 TO LEN(TabOrder$)
                ID& = ASC(TabOrder$, K&)
                INCR Obj&
                CALL skTabStop(hEdit&(ID&))
            NEXT

            REDIM Item$(0)
            CALL skSplitS(cfgStr$(18), Item$(), CHR$(124), hCTL, hFont&, butL&, ButW&)
            CALL skGetTextExtent(hCTL&, hFont&, " ", Side&, ButH&)
            NbrButton& = UBOUND(Item$)

            UseSide& = skButtonMargin: IF UseSide& = 0 THEN UseSide& = Side& + 3        
            ButW& = ButW& + UseSide& * 2 
            ButH& = ButH& + 6
            ButL& = NbrButton& * ButW& + (NbrButton& - 1) * 4
            xLeft& = (650-70 - ButL& - 20) \ 2: yLeft& = 376+71-203
         
            hGroup& = skGroupBox(hCTL&, xLeft&, yLeft&, ButL& + 20, ButH& * 2 + 31, cfgStr$(17), hFont&, skGetSysColor(%SKCOLOR_WINDOWTEXT))

            xLeft& = xLeft& + 10: yLeft& = yLeft& + 17
            sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
            sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
            WasXleft& = xLeft&
            IDREQFIRST& = Obj& + 1: IDREQLAST& = Obj& + NbrButton&
            REDIM hBut3D&(1 TO NbrButton&)
            FOR B& = 1 TO NbrButton&
                INCR Obj&
                sk.button = 1
                hBut3D&(B&) = skBut3D(hCTL&, Item$(B&), hFont&, xLeft&, yLeft&, ButW&, ButH&, Obj&, sk)
                CALL skTabStop(hBut3D&(B&))
                xLeft& = xLeft& + ButW& + 4
            NEXT
            INCR Obj&: IDSTART& = Obj&
            sk.button = 1
            hButStart& = skBut3D(hCTL&, cfgStr$(19), hFont&, wasXleft&, yLeft& + ButH& + 4, ButL&, ButH&, Obj&, sk)
            CALL skTabStop(hButStart&)
         
            INCR Obj&: pWidth& = 300
            xP& = (650-70-2 - pWidth&) \ 2: yP& = 376+71-203 + ButH& * 2 + 31 + 3
            Smooth& = 0
            hProgress& = skProgress32(hCTL&, Obj&, xP&, yP&, pWidth&, 17, Smooth&)

            CALL MakeCombo
            CALL SetFocus(hTheme&)
            
         END IF
         
    CASE %WM_SYSCOMMAND
	 IF wParam& = %SC_CLOSE THEN

            DIM cXY AS POINTAPI
	    CALL ShowWindow(hFrame&, %SW_RESTORE)
	    CALL GetWindowRect(hFrame&, rc)
	    Wdth& =  rc.nRight - rc.nLeft
	    Hght& = rc.nBottom - rc.nTop
            cXY.X = 0: cXY.Y = 0: CALL ClientToScreen(hFrame&, cXY)
	    CALL Config(cXY.X, cXY.Y, Wdth&, Hght&, 1)

            CALL PostQuitMessage(0)
	    FUNCTION = 1
	 ELSEIF wParam& = 0 THEN

            tNotify$ = skAuthor$ + "||ZAP Image solution|http://www.zapsolution.com|e-mail: pterrier@infonie.fr|| copyright " + RIGHT$(DATE$, 4) + " Patrice Terrier|All rights reserved."
	    sk.Icon = LoadIcon(hInst&, "PROGRAM")
	    sk.Edge = %EDGE_ETCHED
	    sk.Just = %SK_CENTERED
	    sk.Effect = %SK_CENTERED
            sk.Print3D = %SK_3DOUT
            sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
            sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
   	  ' UseButton$ = "Button1|Button2|Button3"  
	    UseButton$ = "" ' Uses the default "ok" button

            CALL skMsgBox(hFrame&, skCaptionFont, skGetCTLText(hFrame&), tNotify$, UseButton$, sk)
	                
	 END IF

    CASE %WM_COMMAND
	 IF skMacte$(wP%, Mact$()) = "END" THEN
	    CALL SendMessage (hWnd&, %WM_SYSCOMMAND, %SC_CLOSE, lParam&)
	    FUNCTION = 1
	    EXIT FUNCTION
	 END IF

	 SELECT CASE wP%
         CASE 1 TO 9 ' Radio buttons
              IF WasInput& THEN
                 IF wP% > 7 THEN
                    CALL ShowWindow(hBound&(WasInput&), %SW_SHOW)
                 ELSE
                    CALL ShowWindow(hBound&(WasInput&), %SW_HIDE)
                 END IF
                 CALL SetFocus(hEdit&(WasInput&))
                 ski(WasInput&).Search = wP%

                 GOSUB ShowType
              END IF
         CASE IDSECUR&

              IsLocked& = skExist(PassFile$)
              IF IsLocked& THEN
                 CALL skFOpen&(PassFile$, 0, 2, hPwd&)
                 PassWord$ = SPACE$(skFlof(hPwd&))
                 CALL skFget(hPwd&, PassWord$)
                 CALL skFClose(hPwd&)
                 PassWord$ = skDecrypt(PassWord$)
              ELSE
                 PassWord$ = ""
              END IF

              IF IsLocKed& THEN
                 Caption$ = skGetCTLText(hSecur&)
                 tNotify$ = cfgStr$(41)
                 sk.Icon = 0
                 sk.Edge = %EDGE_ETCHED
                 sk.Just = %SK_CENTERED
                 sk.Effect = %SK_CENTERED
                 sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
                 sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
                 sk.Print3D = 0
                 sk.Isize = 8
                 sk.Itype = 5 ' Secret
                 sk.ButFocus = 1
                 sk.ButEscape = 2
                 UserInput$ = ""
                 sk.Tile = 1
                 
                 IF skInputBox(hFrame&, hFont&, Caption$, tNotify$, cfgStr$(32), UserInput$, sk) = 1 THEN
                    IF UserInput$ = PassWord$ THEN IsLocked& = 0
                 END IF
                 
                 GOSUB ShowPwStatus
              ELSE
                 GOSUB QueryFullPW
              END IF

         CASE IDTHEME&
              IF ID& = %CBN_SELENDOK THEN
                 UseTheme$ = skGetCTLText(lParam&)
                 CALL MakeCombo
              END IF
         CASE IDREQFIRST& TO IDREQLAST&

              SELECT CASE wP%

              CASE IDREQFIRST&       ' Save request

              CASE IDREQFIRST& + 1   ' Clear grid
                   CALL ClearInput(hBound&())
                   FOR K& = 1 TO 9
                       CALL SendMessage(hBut&(K&), %BM_SETCHECK, 0, 0)
                       CALL EnableWindow(hBut&(K&), 1)
                       CALL skSetRadio(hBut&(K&), 0)
                   NEXT
                   CALL skSetCTLText(hStatus&, "")
                   WasInput& = 0

              CASE IDREQLAST&        ' Load request

              END SELECT
         
         CASE IDSTART&
              
              IF ProgressOn& = 0 THEN
                 ProgressOn& = -1
                 MaxRec& = 777
                 FOR Rec& = 1 TO MaxRec&             

                     TimerGet??? = TimeGetTime
                     DO WHILE TimeGetTime < TimerGet??? + 5
                  
                        Percent& = CLNG((Rec& / MaxRec&) * 100)
                        IF Percent& <> WasPercent& THEN
                           CALL SendMessage(hProgress&, %PBM_SETPOS, Percent&, 0)
                        END IF
                        WasPercent& = Percent&

                        GOSUB TestAbort: IF UserAbort& THEN EXIT DO
                     LOOP
                     IF UserAbort& THEN EXIT FOR

                 NEXT
                 CALL skWait(1000)
                 
                 CALL SendMessage(hProgress&, %PBM_SETPOS, 0, 0)
                 ProgressOn& = 0
              END IF
               
         CASE 101 ' Set the password
              IsLocked& = skExist(PassFile$)
              IF IsLocked& THEN
                 CALL skFOpen&(PassFile$, 0, 2, hPwd&)
                 PassWord$ = SPACE$(skFlof(hPwd&))
                 CALL skFget(hPwd&, PassWord$)
                 CALL skFClose(hPwd&)
                 PassWord$ = skDecrypt(PassWord$)
              ELSE
                 PassWord$ = ""
              END IF
              GOSUB QueryFullPW
         CASE 103 ' Input password
              Msg& = %WM_COMMAND: wP% = IDSECUR&: GOTO NewMessage

         CASE 201 ' Input box
              Caption$ = REMOVE$(skGetMenuString(201), "&")
              tNotify$ = cfgStr$(1)
              sk.Icon = LoadIcon(%NULL, BYVAL %IDI_QUESTION)
              sk.Edge = %EDGE_ETCHED
              sk.Just = 0 ' %SK_CENTERED
              sk.Effect = %SK_PULSE
              sk.Fore = skGetSysColor(%SKCOLOR_CAPTIONTEXT)
              sk.Back = skGetSysColor(%SKCOLOR_ACTIVECAPTION)
              sk.Print3D = %SK_3DIN 
              sk.Isize = 8
              sk.Itype = 0
              sk.ButFocus = 1
              sk.ButEscape = 2
              UserInput$ = ""
              sk.Tile = 1                
              ButIs& = skInputBox(hFrame&, skCaptionfont, Caption$, tNotify$, cfgStr$(34), UserInput$, sk)
         
         CASE 203 ' Message box
              tNotify$ = skAuthor$ + "||ZAP Image solution|http://www.zapsolution.com|e-mail: pterrier@infonie.fr|| copyright " + RIGHT$(DATE$, 4) + " Patrice Terrier|All rights reserved."
              sk.Icon = LoadIcon(hInst&, "PROGRAM")
              sk.Edge = %EDGE_BUMP
              'sk.Edge = %EDGE_ETCHED
              'sk.Edge = %EDGE_RAISED
              'sk.Edge = %EDGE_SUNKEN
              sk.Just = %SK_CENTERED
	      sk.Effect = %SK_CENTERED
              sk.Print3D = 0
              sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
              sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
	      sk.Tile = 1
              CALL skMsgBox(hFrame&, hFont&, "W i n L I F T", tNotify$, "", sk)

         CASE 32202 TO 32215 ' Focus on input fields
              IF (ID& = %EN_SETFOCUS OR ID& = %CBN_SETFOCUS) AND WasInput& <> wP% - 32200 THEN
                 WasInput& = wP% - 32200

                 Char& = ski(WasInput&).Itype
                 IF Char& = 1 OR Char& = 10 THEN ' Numeric
                    Item& = 13
                 ELSEIF Char& = 4 THEN           ' Date
                    Item& = 14
                 ELSE                            ' Alphanumeric
                    Item& = 15
                 END IF
                 IF Item& = 15 THEN
                    FOR K& = 1 TO 5
                        CALL SendMessage(hBut&(K&), %BM_SETCHECK, 0, 0)
                        CALL EnableWindow(hBut&(K&), 1)
                        CALL skSetRadio(hBut&(K&), 0)
                    NEXT
                    FOR K& = 6 TO 9
                        CALL SendMessage(hBut&(K&), %BM_SETCHECK, 0, 0)
                        CALL EnableWindow(hBut&(K&), 0)
                        CALL skSetRadio(hBut&(K&), 0)
                    NEXT
                 ELSE
                    FOR K& = 1 TO 4
                        CALL SendMessage(hBut&(K&), %BM_SETCHECK, 0, 0)
                        CALL EnableWindow(hBut&(K&), 0)
                        CALL skSetRadio(hBut&(K&), 0)
                    NEXT
                    FOR K& = 5 TO 9
                        CALL SendMessage(hBut&(K&), %BM_SETCHECK, 0, 0)
                        CALL EnableWindow(hBut&(K&), 1)
                        CALL skSetRadio(hBut&(K&), 0)
                    NEXT
                 END IF

                 IF ski(WasInput&).Search = 0 THEN
                    CALL SendMessage(hBut&(5), %BM_SETCHECK, 1, 0)
                    ski(WasInput&).Search = 5
                    CALL skSetRadio(hBut&(5), 1)
                 END IF

                 GOSUB ShowType
                 
              END IF
         CASE 32502 TO 32515 ' Focus on hBound fields
              WasInput& = wP% - 32500
              IF ski(WasInput&).Search > 0 THEN
                 FOR K& = 1 TO 9
                     CALL SendMessage(hBut&(K&), %BM_SETCHECK, 0, 0)
                     IF K& < 5 THEN
                        CALL EnableWindow(hBut&(K&), 0)
                     ELSE
                        CALL EnableWindow(hBut&(K&), 1)
                     END IF
                     CALL skSetRadio(hBut&(K&), 0)
                 NEXT
                 CALL SendMessage(hBut&(ski(WasInput&).Search), %BM_SETCHECK, 1, 0)
                 CALL skSetRadio(hBut&(ski(WasInput&).Search), 1)
                 GOSUB ShowType
              END IF
	 END SELECT
	 
    CASE %WM_DESTROY

         CALL skDeleteObject(BackBrush&)
       ' NOT required but better to free-up button's bitmap resources
         CALL skDeleteMemBMP(hSecur&)         ' Better to kill the button bitmap resource
         FOR K& = 1 TO UBOUND(hBut3D&)         
             CALL skDeleteMemBMP(hBut3D&(K&)) ' Better to kill the button bitmap resource
         NEXT                                  
         CALL skDeleteMemBMP(hButStart&)      ' Better to kill the button bitmap resource

    END SELECT

    FUNCTION = DefWindowProc(hWnd&, Msg&, wParam&, lParam&)
    
    EXIT FUNCTION

ShowType:
    Char& = ski(WasInput&).Itype
    IF Char& = 1 OR Char& = 10 THEN ' Numeric
       Item& = 13
    ELSEIF Char& = 4 THEN           ' Date
       Item& = 14
    ELSE                            ' Alpha
       Item& = 15
    END IF
    Af$ = cfgStr$(Item&)
    IF ski(WasInput&).Search > 0 THEN
       CALL SendMessage(hBut&(ski(WasInput&).Search), %BM_SETCHECK, 1, 0)
       CALL skSetRadio(hBut&(ski(WasInput&).Search), 1)
       Af$ = Af$ + " (" + cfgStr$(ski(WasInput&).Search + 3) + ")"
    END IF

  ' Redraw objects within hCTL&
    CALL InvalidateRect(hCTL&, BYVAL %NULL, 0)

ShowStatusLine:
    CALL skSetCTLText(hStatus&, Af$)
    RETURN

TestAbort:
    UserAbort& = 0
    WHILE PeekMessage(wMsg, %NULL, %NULL, %NULL, %PM_REMOVE)

       Dispatch& = -1
      
     ' If ever they have the idea to use the close button while a job is on progress
       IF wMsg.message = %WM_SYSCOMMAND AND wMsg.wParam = %SC_CLOSE THEN
          wMsg.message = %WM_KEYDOWN: wMsg.wParam = 27
          Dispatch& = 0
       END IF

       IF wMsg.message = %WM_KEYDOWN AND wMsg.wParam = 27 THEN
          BEEP
          sk.Icon = LoadIcon(%NULL, BYVAL %IDI_WARNING)
          sk.Edge = %EDGE_ETCHED
          sk.Just = %SK_CENTERED
          sk.Effect = %SK_PULSE
          sk.Print3D = 0
          sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
          sk.Back = skGetSysColor(%SKCOLOR_WINDOW)
          IF skMsgBox(hFrame&, hFont&, cfgStr$(46), cfgStr$(47), cfgStr$(30), sk) = 1 THEN
             UserAbort& = -1
          END IF
          CALL updateWindow(hFrame&)
       END IF
       IF Dispatch& THEN
          CALL TranslateMessage(wMsg)
          CALL DispatchMessage(wMsg)
       END IF
    WEND
    SLEEP 0
    RETURN

QueryFullPW:
    Caption$ = REMOVE$(skGetMenuString(101), "&")
    sk.Icon = 0
    sk.Fore = skGetSysColor(%SKCOLOR_WINDOWTEXT)
    sk.Back = skGetSysColor(%SKCOLOR_WINDOW)  
    sk.Print3D = 0
    sk.Effect = %SK_MARQUEE 
    sk.Isize = 12
    sk.Iwidth = 60
    sk.Itype = 5
    sk.Edge = %EDGE_ETCHED
    sk.ButFocus = 1
    sk.ButEscape = 2
    sk.Tile = 1
    UserChoice& = skInputPW(hFrame&, hFont&, Caption$, cfgStr$(42), cfgStr$(30), PassWord$, sk)
    IF UserChoice& = 1 AND LEN(PassWord$) THEN
       FlagAttr& = %FILE_ATTRIBUTE_HIDDEN OR %FILE_ATTRIBUTE_READONLY OR %FILE_ATTRIBUTE_SYSTEM
       zTmp = PassFile$
       IF skExist(PassFile$) THEN
          CALL SetFileAttributes(zTmp, %FILE_ATTRIBUTE_NORMAL)
       END IF
       hPW& = CreateFile(zTmp, %GENERIC_WRITE, 0, BYVAL %NULL, _
                         %CREATE_ALWAYS, FlagAttr&, BYVAL %NULL)
       CALL skFPut(hPW&, skEncrypt$(PassWord$))
       CALL skFClose(hPW&)

       IsLocked& = 0
    END IF
ShowPWstatus:
    rc.nLeft = 643
    rc.nTop = 164  
    rc.nRight = rc.nLeft + 32
    rc.nBottom = rc.nTop + 32
    CALL InvalidateRect(hCTL&, rc, 0)
    CALL UpdateWindow(hCTL&)
    RETURN

END FUNCTION

FUNCTION WinMain (BYVAL hInstance     AS LONG, _
		  BYVAL hPrevInstance AS LONG, _
		  lpCmdLine           AS ASCIIZ PTR, _
		  BYVAL iCmdShow      AS LONG) AS LONG

    LOCAL Msg            AS tagMsg
    LOCAL wc             AS WndClassEx
    LOCAL szClassName    AS ASCIIZ * 32

    REDIM PopMnu$(0), Mact$(0, 0), cfgStr$(0), hEdit&(0)

    CALL skSplitN(skExeName, TruePath$, TrueName$)
    zTruePath = TruePath$
    
    hInst& = hInstance&
    hFont& = skDefaultFont

    ScrWidth& = GetSystemMetrics(%SM_CXSCREEN)
    ScrHeight& = GetSystemMetrics(%SM_CYSCREEN)

    ConfigFile$ = TruePath$ + EXTRACT$(TrueName$, ".") + ".SYS"

    IF NOT skExist(ConfigFile$) THEN
       tNotify$ = ConfigFile$ + " missing !"
       sk.Icon = LoadIcon(%NULL, BYVAL %IDI_ERROR)
       sk.Edge = %EDGE_ETCHED
       sk.Just = %SK_CENTERED
       sk.Effect = %SK_CENTERED
       sk.Fore = 128
       sk.Back = skGetSysColor(%SKCOLOR_MSGBOX)
       sk.Tile = 1
       CALL skMsgBox(0, hFont&, TrueName$, tNotify$, "", sk)
       FUNCTION = 2                                ' ERROR_FILE_NOT_FOUND
       EXIT FUNCTION
    END IF

    CALL skReadM(ConfigFile$, BarMnu$, PopMnu$(), Mact$(), Done&)
    hMenu& = skMenu(BarMnu$, PopMnu$(), Mact$())
        
    CALL skReadStr(ConfigFile$, cfgStr$(), Done&)
    
    zTmp = cfgStr$(3)
 
    szClassName = "SKINSDI"
    Style& = %CS_HREDRAW OR %CS_VREDRAW 
    
    wc.cbSize        = SIZEOF(wc)
    wc.style         = Style&
    wc.lpfnWndProc   = CODEPTR(WndProc)
    wc.cbClsExtra    = 0
    wc.cbWndExtra    = 0
    wc.hInstance     = hInst&
    wc.hIcon         = %NULL
    wc.hCursor       = %NULL
    wc.hbrBackground = %NULL                       ' Don't paint class window background
    wc.lpszMenuName  = %NULL
    wc.lpszClassName = VARPTR(szClassName)
    wc.hIconSm       = LoadIcon(hInst&,"PROGRAM")

    CALL RegisterClassEx(wc)
 
    Style& = %WS_POPUP OR %WS_SYSMENU' OR %WS_CLIPCHILDREN
    StyleEx& = 0

'   Tells the engine it should use 
    CALL skWindowStyle(%SK_MINIMIZEBOX OR _        ' MINIMIZEBOX button 
                       %SK_CLOSEBOX OR _           ' CLOSEBOX button
                       %SK_DOCKBOX OR _            ' DOCKBOX button
                       %SK_STATUSBAR)              ' STATUSBAR bottom status bar
        
    Xin& = 728: Yin& = 340
    CALL skSetMaxSize(Xin&, Yin&, xFrame&, yFrame&)

  ' Retrieves last user window coordinates in the config file
    CALL Config(x&, y&, Wdth&, Hght&, 0)
    
    hFrame& = CreateWindowEx(StyleEx&, _
                          szClassName, _           ' window class name
                          zTmp, _                  ' window title
                          Style&, _                ' window style
                          x&, _                    ' initial x position
                          y&, _                    ' initial y position
                          xFrame&, _               ' initial x size
                          yFrame&, _               ' initial y size
                          %NULL, _                 ' parent window handle
                          %NULL, _                 ' window menu handle
                          hInst&, _                ' program instance handle
                          BYVAL %NULL)             ' creation parameters

    hCTLmenu& = skHolder(hFrame&, "SKMENU", 0, 0, CODEPTR(WndProc))
    '*'hCTL& = skHolder(hFrame&, "SKHOLDER", 0, 0, CODEPTR(WndProc))
    hCTL& = skHolder(hFrame&, "SKCLIP", 0, 0, CODEPTR(WndProc))
    hStatus& = skStatusWindow(hFrame&, "")

    hEye& = skAnimate&(hCTL&, skLoadImage("ATOMWHIT.BMP"), 450, 15)

    CALL WndProc(hFrame&, %WM_INITDIALOG, hFrame&, 0)

    CALL ShowWindow(hFrame&, %SW_SHOW)
    CALL UpdateWindow(hFrame&)

    WHILE GetMessage(Msg, %NULL, 0, 0)
       IF skDialogMessage(hFrame&, Msg) = %FALSE THEN
          TranslateMessage Msg
          DispatchMessage Msg
       END IF       
    WEND

    CALL DestroyMenu(hMenu&)       ' Destroy menu handle
    FUNCTION = msg.wParam

END FUNCTION

SUB Config(x&, y&, Wdth&, Hght&, BYVAL Action?)
'
' IF Action? = 0  read frame coordinates
' IF Action? <> 0 save frame coordinates

    CALL skSplitN(skExeName, TruePath$, TrueName$)
    IniFile$ = TruePath$ + EXTRACT$(TrueName$, ".") + ".CFG"

    IF Action? = 0 THEN          ' Read x y frame coordinates
       IF skExist(IniFile$) THEN
	  ErrCode& = skFOpen&(IniFile$, 0, 0, hFile&)
	  IF ErrCode& = 0 THEN Size& = skFlof(hFile&)
       END IF
       IF Size& THEN
	  Buff$ = SPACE$(Size&)
	  ErrCode& = skFGet(hFile&, Buff$)
	  x& = MAX(CVI(MID$(Buff$, 1, 2)), 0)
	  y& = MAX(CVI(MID$(Buff$, 3, 2)), 0)
	  Wdth& = MAX(CVI(MID$(Buff$, 5, 2)), skXmini)
	  Hght& = MAX(CVI(MID$(Buff$, 7, 2)), skYmini)
       ELSE
	  Wdth& = MAX(CVI(MID$(Buff$, 5, 2)), skXmini)
	  Hght& = MAX(CVI(MID$(Buff$, 7, 2)), skYmini)
          x& = MAX&((ScrWidth& - xFrame&) \ 2, 0)
          y& = MAX&((ScrHeight& - yFrame&) \ 2, 0)
       END IF
    ELSE                        ' Save x y frame coordinates
       CALL skKillFile(IniFile$)
       ErrCode& = skFOpen&(IniFile$, 1, 1, hFile&)
       IF ErrCode& = 0 THEN
	  Buff$ = MKI$(x&) + MKI$(y&) + MKI$(Wdth&) + MKI$(Hght&)
	  ErrCode& = skFPut(hFile&, Buff$)
       END IF
    END IF
    CALL skFClose(hFile&)
    Buff$ = ""

END SUB

' Set specifications of the input form.
SUB InitInput(BYVAL hOwner&, BYVAL xBegin&, BYVAL yBegin&, Ti$(), hBound&())

    LOCAL rc AS RECT

    RecSize& = 0

    IsCombo$ = ""
    CheckSize$ = CHR$(1,2,4,7,10,12,15)
    FOR K& = 1 TO LEN(CheckSize$)
        CALL skGetTextExtent(hOwner&, hFont&, skConvert(Ti$(ASC(CheckSize$, K&))), stWidth&, stHeight&)
        xTop& = MAX(xTop&, stWidth& + 2)
    NEXT
    xTop& = xBegin& + xTop&
    yTop& = yBegin& + 3: yStep& = 26

    sk.Fore = RGB(0,0,32)                              ' text color
    sk.Back = RGB(227,245,255)                         ' background color

    ID& = 01                                           ' Field ID 
    sk.Itype = 20                                      ' fied type: enhanced UCASE
    sk.Edge = 2                                        ' double frame
    sk.X = xTop&: sk.Y = yTop&                         ' X, Y coordinates
    sk.Isize = 8                                       ' maximum letters allowed
    UseFont& = hFont&                                  ' font to use
    GOSUB MemoSki

    ID& = 02                                           ' Field ID
    sk.Itype = 0                                       ' field type: ALPHA (mixed case)
    sk.Edge = 1                                        ' single frame
    sk.X = xTop&: sk.Y = sk.Y + yStep&                 ' X, Y coordinates
    sk.Isize = 30                                      ' maximum letters allowed
    sk.ReadOnly = -1                                   ' turn on read only field
    sk.Iwidth = 183                                    ' field width in pixels
    UseFont& = hFont&                                  ' font to use
    Text$ = "Try to press ""D"" in the date field --->"' default text 
    GOSUB MemoSki

    CALL GetWindowRect (hEdit&(ID&), rc)
    CALL skGetTextExtent(hOwner&, hFont&, Ti$(ID& + 1), stWidth&, stHeight&)
    ID& = 03                                           ' Field ID                      
    sk.Itype = 4                                       ' field type: DATE ONLY
    sk.Edge = 1                                        ' single frame                  
    sk.X = sk.X + rc.nRight - rc.nLeft + stWidth& + 8  ' X, Y coordinates              
    sk.Isize = 8                                       ' maximum letters allowed       
    UseFont& = hFont&                                  ' font to use              
    GOSUB MemoSki                                      ' default text         
                                                                         
    ID& = 04                                           ' Field ID
    sk.Itype = 2                                       ' fied type: standard UCASE
    sk.Edge = 1                                        ' single frame
    sk.X = xTop&: sk.Y = sk.Y + yStep&                 ' X, Y coordinates
    sk.Isize = 3                                       ' maximum letters allowed
    UseFont& = hFont&                                  ' font to use
    GOSUB MemoSki

    CALL GetWindowRect (hEdit&(ID&), rc)
    CALL skGetTextExtent(hOwner&, hFont&, Ti$(ID& + 1), stWidth&, stHeight&)
    ID& = 05                                           ' Field ID                 
    sk.Itype = 10                                      ' fied type: INTEGER ONLY
    sk.Edge = 1                                        ' single frame             
    sk.X = sk.X + rc.nRight - rc.nLeft + stWidth& + 8  ' X, Y coordinates         
    sk.Isize = 2                                       ' maximum letters allowed  
    UseFont& = hFont&                                  ' font to use              
    GOSUB MemoSki

    CALL GetWindowRect (hEdit&(ID&), rc)
    CALL skGetTextExtent(hOwner&, hFont&, Ti$(ID& + 1), stWidth&, stHeight&)
    ID& = 06                                           ' Field ID                 
    sk.Itype = 10                                      ' fied type: INTEGER ONLY
    sk.Edge = 1                                        ' single frame             
    sk.X = sk.X + rc.nRight - rc.nLeft + stWidth& + 8  ' X, Y coordinates         
    sk.Isize = 8                                       ' maximum letters allowed  
    UseFont& = hFont&                                  ' font to use              
    GOSUB MemoSki

    ID& = 07                                           ' Field ID                 
    sk.Itype = 10                                      ' fied type: INTEGER ONLY
    sk.Edge = 1                                        ' single frame             
    sk.X = xTop&: sk.Y = sk.Y + yStep&                 ' X, Y coordinates         
    sk.Isize = 5                                       ' maximum letters allowed  
    UseFont& = hFont&                                  ' font to use              
    GOSUB MemoSki

    CALL GetWindowRect (hEdit&(ID&), rc)
    CALL skGetTextExtent(hOwner&, hFont&, Ti$(ID& + 1), stWidth&, stHeight&)
    ID& = 08                                           ' Field ID                 
    sk.Itype = 10                                      ' fied type: INTEGER ONLY
    sk.Edge = 1                                        ' single frame             
    sk.X = sk.X + rc.nRight - rc.nLeft + stWidth& + 8  ' X, Y coordinates         
    sk.Isize = 5                                       ' maximum letters allowed  
    UseFont& = hFont&                                  ' font to use              
    GOSUB MemoSki

    CALL GetWindowRect (hEdit&(ID&), rc)
    CALL skGetTextExtent(hOwner&, hFont&, Ti$(ID& + 1), stWidth&, stHeight&)
    ID& = 09                                           ' Field ID                 
    sk.Itype = 1                                       ' fied type: NUMERIC
    sk.Edge = 1                                        ' single frame             
    sk.X = sk.X + rc.nRight - rc.nLeft + stWidth& + 8  ' X, Y coordinates         
    sk.Isize = 9                                       ' maximum letters allowed  
    UseFont& = hFont&                                  ' font to use
    GOSUB MemoSki

    CALL GetWindowRect (hEdit&(ID&), rc)
    CALL skGetTextExtent(hOwner&, hFont&, Ti$(ID& + 1), stWidth&, stHeight&)
    ID& = 10                                           ' Field ID                 
    sk.Itype = 10                                      ' fied type: INTEGER ONLY
    sk.Edge = 1                                        ' single frame             
    sk.X = xTop&: sk.Y = sk.Y + yStep&                 ' X, Y coordinates         
    sk.Isize = 4                                       ' maximum letters allowed  
    Text$ = RIGHT$(DATE$, 4)                           ' default text
    UseFont& = hFont&                                  ' font to use
    GOSUB MemoSki

    CALL GetWindowRect (hEdit&(ID&), rc)
    CALL skGetTextExtent(hOwner&, hFont&, Ti$(ID& + 1), stWidth&, stHeight&)
    ID& = 11                                           ' Field ID                 
    sk.Itype = 10                                      ' fied type: INTEGER ONLY
    sk.Edge = 1                                        ' single frame             
    sk.X = sk.X + rc.nRight - rc.nLeft + stWidth& + 8  ' X, Y coordinates         
    sk.Isize = 2                                       ' maximum letters allowed  
    sk.Iclass = 2                                      ' ctrl class: UpDn control
    sk.MinV = 1                                        ' UpDn minimum value
    sk.MaxV = 12                                       ' UpDn maximum value
    sk.SeedV = VAL(LEFT$(DATE$,2))                     ' UpDn seed value
    UseFont& = hFont&                                  ' font to use              
    GOSUB MemoSki

    ID& = 12                                           ' Field ID                 
    sk.Itype = 20                                      ' fied type: enhanced UCASE
    sk.Edge = 1                                        ' single frame             
    sk.X = xTop& : sk.Y = sk.Y + yStep&                ' X, Y coordinates         
    sk.Isize = 40                                      ' maximum letters allowed  
    sk.Iwidth = 308                                    ' field width in pixels
    sk.Iclass = 1                                      ' ctrl class: COMBO with input              
    UseFont& = hFont&                                  ' font to use 
    GOSUB MemoSki

    ID& = 13                                           ' Field ID                    
    sk.Itype = 20                                      ' fied type: enhanced UCASE   
    sk.Edge = 1                                        ' single frame                
    sk.X = xTop&: sk.Y = sk.Y + yStep&                 ' X, Y coordinates            
    sk.Isize = 40                                      ' maximum letters allowed     
    sk.Iwidth = 308                                    ' field width in pixels       
    sk.Iclass = 10                                     ' ctrl class: COMBO read only
    UseFont& = hFont&                                  ' font to use                 
    GOSUB MemoSki

    ID& = 14                                           ' Field ID
    sk.Itype = 0                                       ' field type: ALPHA
    sk.Edge = 1                                        ' single frame
    sk.X = xTop&: sk.Y = sk.Y + yStep&                 ' X, Y coordinates
    sk.Isize = 200                                     ' maximum letters allowed
    sk.Iwidth = 482                                    ' field width in pixels
    UseFont& = hFont&                                  ' font to use
    GOSUB MemoSki

    ID& = 15                                           ' Field ID
    sk.Itype = 6                                       ' field type: BOOLEAN
    sk.Edge = 2                                        ' double frame
    sk.X = xTop&: sk.Y = sk.Y + yStep&                 ' X, Y coordinates
    sk.Isize = 1                                       ' maximum lette allowed
    UseFont& = hFont&                                  ' font to use
    GOSUB MemoSki

    sk.X = 0: sk.Y = 0
    EXIT SUB

MemoSki:
    IF sk.ReadOnly AND sk.Fore = 0 THEN
       sk.Back = RGB(223,223,223)
    ELSEIF sk.Fore = 0 THEN
       sk.Back = RGB(255,255,255)
    END IF
    ski(ID&).Itype = sk.Itype
    ski(ID&).Isize = sk.Isize
    ski(ID&).Iwidth = sk.Iwidth
    ski(ID&).ReadOnly = sk.ReadOnly
    ski(ID&).X = sk.X
    ski(ID&).Y = sk.Y
    ski(ID&).Edge = sk.Edge
    ski(ID&).Fore = sk.Fore
    ski(ID&).Back = sk.Back
    ski(ID&).MinV = sk.MinV
    ski(ID&).MaxV = sk.MaxV
    ski(ID&).SeedV = sk.SeedV
    ski(ID&).Iclass = sk.Iclass
    ski(ID&).offset = RecSize& + 1
    RecSize& = RecSize& + ski(ID&).Isize

    IF sk.Iclass = 1 OR sk.Iclass = 10 THEN IsCombo$ = IsCombo$ + CHR$(ID&)

    IF ID& < 16 THEN
    
       hEdit&(ID&) = skInput&(hOwner&, UseFont&, Ti$(ID&), Text$, ID& + 32200, sk)
       ski(ID&).hEdit = sk.hEdit
       ski(ID&).hTitle = sk.hTitle

     ' Create hidden edit controls to allow range input.
       IF INSTR(CHR$(0,2,20), CHR$(ski(ID&).Itype)) = 0 THEN
          CALL GetWindowRect(hEdit&(ID&), rc)
          sk.X = sk.X + rc.nRight - rc.nLeft + 1
          hBound&(ID&) = skInput&(hOwner&, UseFont&, "", "", ID& + 32500, sk)
          CALL ShowWindow(hBound&(ID&), %SW_HIDE)
       END IF
    
    END IF
    Text$ = ""
    RETURN
END SUB

SUB ClearInput(hBound&())
  ' Clear the input grid
    FOR K& = 1 TO UBOUND(ski)
        IF ski(K&).Iclass = 1 OR ski(K&).Iclass = 10 THEN
           CALL SendMessage(hEdit&(K&), %CB_SETCURSEL, -1, 0)
        ELSE
           CALL skSetCTLText(ski(K&).hEdit, "")
           IF hBound&(K&) THEN
              CALL skSetCTLText(hBound&(K&), "")
              CALL ShowWindow(hBound&(K&), %SW_HIDE)
           END IF
        END IF
        ski(K&).Search = 0
    NEXT
END SUB

SUB MakeCombo
    FilName$ = zTruePath + UseTheme$ + ".THM"
    LenCombo& = LEN(IsCombo$)
    FOR K& = 1 TO LenCombo&
        I& = ASC(IsCombo$, K&)
        CALL SendMessage(hEdit&(I&), %CB_RESETCONTENT, 0, 0)
        CALL skAddStringCombo(hEdit&(I&), "")
    NEXT
    DO
        Bf$ = skBufin$(FilName$, Done&)
        IF LEN(Bf$) THEN
           FOR K& = 1 TO LenCombo&
               I& = ASC(IsCombo$, K&)
               CALL skAddStringCombo(hEdit&(I&), Bf$)
           NEXT
        END IF
    LOOP UNTIL Done&
END SUB

